'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-6bdbeffd.js');

const sTooltipCss = ":host{all:initial;display:inline;--tooltip-display:none;--tooltip-left:0;--tooltip-top:0;--tooltip-arrow-right:unset;--tooltip-arrow-bottom:unset;--tooltip-arrow-left:unset;--tooltip-border-width:unset;--tooltip-border-color:unset;--tooltip-color:unset;--tooltip-background-color:unset;--tooltip-max-width:unset;--tooltip-max-height:unset;--tooltip-opacity:unset;--tooltip-z-index:unset;--tooltip-shadow:unset;--tooltip-border-radius:unset;--tooltip-arrow-size:unset}#tooltip-container{z-index:var(--tooltip-z-index);pointer-events:none;display:var(--tooltip-display);position:fixed;left:var(--tooltip-left);top:var(--tooltip-top);opacity:var(--tooltip-opacity)}#tooltip-container.styled{background-color:var(--tooltip-background-color);border-radius:var(--tooltip-border-radius);padding:10px;color:var(--tooltip-color);max-width:var(--tooltip-max-width);max-height:var(--tooltip-max-height);border-style:solid;border-width:var(--tooltip-border-width);border-color:var(--tooltip-border-color);-webkit-box-shadow:var(--tooltip-shadow);box-shadow:var(--tooltip-shadow)}#tooltip-container.styled.arrow:before,#tooltip-container.styled.arrow:after{content:\"\";width:0;height:0;position:absolute;border-style:solid}#tooltip-container.styled.arrow.top:before{border-left-width:var(--tooltip-arrow-size);border-left-color:transparent;border-right-width:var(--tooltip-arrow-size);border-right-color:transparent;border-bottom-width:var(--tooltip-arrow-size);border-bottom-color:transparent;top:100%;left:50%;margin-left:calc(0px - var(--tooltip-arrow-size));border-top-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-top-color:var(--tooltip-border-color)}#tooltip-container.styled.arrow.top:after{border-left-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-left-color:transparent;border-right-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-right-color:transparent;border-bottom-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-bottom-color:transparent;top:100%;left:50%;margin-left:calc(0px - var(--tooltip-arrow-size) + var(--tooltip-border-width));border-top-color:var(--tooltip-background-color);border-top-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width) * 2)}#tooltip-container.styled.arrow.bottom:before{border-left-width:var(--tooltip-arrow-size);border-left-color:transparent;border-right-width:var(--tooltip-arrow-size);border-right-color:transparent;border-top-width:var(--tooltip-arrow-size);border-top-color:transparent;bottom:100%;left:50%;margin-left:calc(0px - var(--tooltip-arrow-size));border-bottom-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-bottom-color:var(--tooltip-border-color)}#tooltip-container.styled.arrow.bottom:after{border-left-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-left-color:transparent;border-right-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-right-color:transparent;border-top-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-top-color:transparent;bottom:100%;left:50%;margin-left:calc(0px - var(--tooltip-arrow-size) + var(--tooltip-border-width));border-bottom-color:var(--tooltip-background-color);border-bottom-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width) * 2)}#tooltip-container.styled.arrow.left:before{border-top-width:var(--tooltip-arrow-size);border-top-color:transparent;border-bottom-width:var(--tooltip-arrow-size);border-bottom-color:transparent;border-right-width:var(--tooltip-arrow-size);border-right-color:transparent;left:100%;top:50%;margin-top:calc(0px - var(--tooltip-arrow-size));border-left-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-left-color:var(--tooltip-border-color)}#tooltip-container.styled.arrow.left:after{border-top-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-top-color:transparent;border-bottom-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-bottom-color:transparent;border-right-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-right-color:transparent;left:100%;top:50%;margin-top:calc(0px - var(--tooltip-arrow-size) + var(--tooltip-border-width));border-left-color:var(--tooltip-background-color);border-left-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width) * 2)}#tooltip-container.styled.arrow.right:before{border-top-width:var(--tooltip-arrow-size);border-top-color:transparent;border-bottom-width:var(--tooltip-arrow-size);border-bottom-color:transparent;border-left-width:var(--tooltip-arrow-size);border-left-color:transparent;right:100%;top:50%;margin-top:calc(0px - var(--tooltip-arrow-size));border-right-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-right-color:var(--tooltip-border-color)}#tooltip-container.styled.arrow.right:after{border-top-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-top-color:transparent;border-bottom-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-bottom-color:transparent;border-left-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width));border-left-color:transparent;right:100%;top:50%;margin-top:calc(0px - var(--tooltip-arrow-size) + var(--tooltip-border-width));border-right-color:var(--tooltip-background-color);border-right-width:calc(var(--tooltip-arrow-size) - var(--tooltip-border-width) * 2)}";

const STooltip = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.shouldShowTooltip = false;
    this._isTooltipEnabled = false;
    this.margin = 10;
    this.orientation = 'bottom';
    this.followMouse = false;
    this.noDefaultStyle = false;
    this.noArrow = false;
    this.showDelay = 100;
    this.hideDelay = 100;
    this.color = 'white';
    this.backgroundColor = 'black';
    this.maxWidth = '500px';
    this.maxHeight = '300px';
    this.borderWidth = '0px';
    this.borderColor = 'white';
    this.opacity = .8;
    this.zIndex = 99999;
    this.shadow = '0px 5px 10px 0px grey';
    this.borderRadius = '10px';
    this.arrowSize = '10px';
  }
  get isTooltipEnabled() {
    return this._isTooltipEnabled;
  }
  set isTooltipEnabled(value) {
    if (value !== this._isTooltipEnabled) {
      this._isTooltipEnabled = value;
      this.updateCSSVariable('--tooltip-display', value ? 'block' : 'none');
      if (!value) {
        this.hostElement.shadowRoot.querySelector('#tooltip-container').innerHTML = '<slot/>';
      }
    }
  }
  get attachedElements() {
    if (this.attachTo) {
      if (typeof this.attachTo === 'string') {
        return document.querySelectorAll(this.attachTo);
      }
      else {
        return this.attachTo;
      }
    }
    else {
      return [this.hostElement.parentElement];
    }
  }
  updateColor(value) {
    this.updateCSSVariable('--tooltip-color', value);
  }
  updateBackgroundColor(value) {
    this.updateCSSVariable('--tooltip-background-color', value);
  }
  updateMaxWidth(value) {
    this.updateCSSVariable('--tooltip-max-width', value);
  }
  updateMaxHeight(value) {
    this.updateCSSVariable('--tooltip-max-height', value);
  }
  updateBorderWidth(value) {
    this.updateCSSVariable('--tooltip-border-width', value);
  }
  updateBorderColor(value) {
    this.updateCSSVariable('--tooltip-border-color', value);
  }
  updateOpacity(value) {
    this.updateCSSVariable('--tooltip-opacity', value.toString());
  }
  updateZIndex(value) {
    this.updateCSSVariable('--tooltip-z-index', value.toString());
  }
  updateShadow(value) {
    this.updateCSSVariable('--tooltip-shadow', value);
  }
  updateBorderRadius(value) {
    this.updateCSSVariable('--tooltip-border-radius', value);
  }
  updateArrowSize(value) {
    this.updateCSSVariable('--tooltip-arrow-size', value);
  }
  connectedCallback() {
    this.attachedElements.forEach(attachedElement => {
      attachedElement.addEventListener('mouseover', event => {
        this.shouldShowTooltip = true;
        setTimeout(() => {
          if (event.target.matches(':hover')) {
            this.isTooltipEnabled = true;
            this.tooltipText = event.target.getAttribute('data-s-tooltip-text');
            this.updateTooltipPosition(event);
          }
        }, this.showDelay);
      });
      attachedElement.addEventListener('mouseout', () => {
        this.shouldShowTooltip = false;
        setTimeout(() => {
          if (!this.shouldShowTooltip) {
            this.isTooltipEnabled = false;
          }
        }, this.hideDelay);
      });
      attachedElement.addEventListener('mousemove', event => {
        if (this.shouldShowTooltip) {
          this.tooltipText = event.target.getAttribute('data-s-tooltip-text');
          this.updateTooltipPosition(event);
        }
      });
    });
    this.initializeCSSVariables();
  }
  render() {
    return (index.h(index.Host, null, index.h("div", { id: "tooltip-container", class: [
        this.orientation,
        this.noDefaultStyle ? '' : 'styled',
        this.noArrow ? '' : 'arrow'
      ].join(' ') }, this.tooltipText && index.h("div", { innerHTML: this.tooltipText }), !this.tooltipText && index.h("slot", null))));
  }
  updateTooltipPosition(mouseEvent) {
    let x = 0, y = 0;
    const targetElement = mouseEvent.target;
    if (this.followMouse) {
      x = mouseEvent.x;
      y = mouseEvent.y;
    }
    else {
      const { top, right, bottom, left, width, height } = targetElement.getBoundingClientRect();
      switch (this.orientation) {
        case 'top':
          x = right - width / 2;
          y = top;
          break;
        case 'right':
          x = right;
          y = bottom - height / 2;
          break;
        case 'bottom':
          x = right - width / 2;
          y = bottom;
          break;
        case 'left':
          x = left;
          y = bottom - height / 2;
          break;
      }
    }
    this.setTooltipPosition(x, y);
  }
  setTooltipPosition(x, y) {
    const tooltipContainerElement = this.hostElement.shadowRoot.querySelector('#tooltip-container');
    const tooltipWidth = tooltipContainerElement.clientWidth;
    const tooltipHeight = tooltipContainerElement.clientHeight;
    let tooltipLeft = x;
    let tooltipTop = y;
    switch (this.orientation) {
      case 'top':
        tooltipLeft = x - tooltipWidth / 2;
        tooltipTop = y - tooltipHeight - this.margin;
        break;
      case 'right':
        tooltipLeft = x + this.margin;
        tooltipTop = y - tooltipHeight / 2;
        break;
      case 'bottom':
        tooltipLeft = x - tooltipWidth / 2;
        tooltipTop = y + this.margin;
        break;
      case 'left':
        tooltipLeft = x - tooltipWidth - this.margin;
        tooltipTop = y - tooltipHeight / 2;
        break;
    }
    this.updateCSSVariable('--tooltip-left', `${tooltipLeft}px`);
    this.updateCSSVariable('--tooltip-top', `${tooltipTop}px`);
  }
  initializeCSSVariables() {
    this.updateColor(this.color);
    this.updateBackgroundColor(this.backgroundColor);
    this.updateMaxWidth(this.maxWidth);
    this.updateMaxHeight(this.maxHeight);
    this.updateBorderWidth(this.borderWidth);
    this.updateBorderColor(this.borderColor);
    this.updateOpacity(this.opacity);
    this.updateZIndex(this.zIndex);
    this.updateShadow(this.shadow);
    this.updateBorderRadius(this.borderRadius);
    this.updateArrowSize(this.arrowSize);
  }
  updateCSSVariable(variableName, value) {
    this.hostElement.style.setProperty(variableName, value);
  }
  get hostElement() { return index.getElement(this); }
  static get watchers() { return {
    "color": ["updateColor"],
    "backgroundColor": ["updateBackgroundColor"],
    "maxWidth": ["updateMaxWidth"],
    "maxHeight": ["updateMaxHeight"],
    "borderWidth": ["updateBorderWidth"],
    "borderColor": ["updateBorderColor"],
    "opacity": ["updateOpacity"],
    "zIndex": ["updateZIndex"],
    "shadow": ["updateShadow"],
    "borderRadius": ["updateBorderRadius"],
    "arrowSize": ["updateArrowSize"]
  }; }
};
STooltip.style = sTooltipCss;

exports.s_tooltip = STooltip;
